const { EmbedBuilder } = require('discord.js');
var unirest = require('unirest');
const jsonfile = require('jsonfile')

module.exports = {
  name: "create-session",
  description: "create a new session chat",
  private: true,
  run: async (client, interaction) => {
    const file = './cache/' + interaction.user.id

    // The Auth stuff here is internal to my set up only and may be removed if you use this bot.
    // My chat GUI for Serge is locked down by basic auth in apache to safe guard from
    // Users issuing mulitple jobs at a time until there is some built in way to do so.
    unirest
      .post(`https://${process.env.PUBLIC_URL}/api/chat`)
      .headers({ 'Accept': 'application/json', 'Content-Type': 'application/json' })
      .auth({
        user: process.env.USERNAME,
        pass: process.env.PASS,
        sendImmediately: true
      })
      .then((response) => {
        const obj = { id: response.body }

        jsonfile.writeFile(file, obj, function (err) {
          if (err) console.error(err)
        })

        const embed = new EmbedBuilder()
          .setColor("#FF0000")
          .setTitle("New Chat Session Started!")
          .setDescription(`New Chat Session ID: \n` + response.body)
          .setTimestamp()
          .setFooter({ text: `Requested by ${interaction.user.tag}`, iconURL: `${interaction.user.displayAvatarURL()}` });
        interaction.followUp({ embeds: [embed] });
      })
  },
};